package de.hmmh.pmt.db;

import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;
import lombok.*;

@NoArgsConstructor
@AllArgsConstructor
@Getter
@Setter
@Entity
@IdClass(AllocationId.class)
@Table(name = "allocation")
public class Allocation {

    @Id
    @Column(name = "project_id")
    @Setter(AccessLevel.NONE)
    private Long projectId;
    
    @ManyToOne
    @JoinColumn(name = "project_id", referencedColumnName = "id", insertable = false, updatable = false)
    private Project project;
    
    @Id
    private Long employeeId;
    
    @NotNull
    private Long role; // This is a QualificationId
    
    public void setProject(Project project) {
        this.project = project;
        this.projectId = project.getId();
    }
}
