package de.hmmh.pmt.db;

import jakarta.persistence.*;
import jakarta.validation.ConstraintViolation;
import jakarta.validation.Validation;
import jakarta.validation.Validator;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Size;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.time.LocalDateTime;
import java.util.Set;

@NoArgsConstructor
@AllArgsConstructor
@Getter
@Setter
@Entity
@Table(name = "project")
public class Project {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotBlank
    @Size(min = 3, max = 64)
    private String name;

    @NotBlank
    @Size(min = 10)
    private String goal;

    @NotNull
    private Long customerId;

    @NotNull
    private Long administratorId; // Is an Employee

    @NotNull
    private LocalDateTime start;

    @NotNull
    private LocalDateTime plannedEnd;

    private LocalDateTime realEnd; // Cant be named just "end" because it's and SQL Keyword
}
