package de.hmmh.pmt.util;

import de.hmmh.pmt.employee.ApiClientFactory;
import de.hmmh.pmt.employee.dtos.EmployeeResponseDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Component;
import org.springframework.web.client.HttpClientErrorException;
import org.springframework.web.client.RestClientException;

@Component
public class ApiTools {

    @Autowired
    private ApiClientFactory apiClientFactory;

    public record CheckEmployeeRecord(EmployeeResponseDTO employee, HttpStatus status) {}
    public CheckEmployeeRecord checkEmployeeExists(long id) {
        EmployeeResponseDTO employee;
        try {
            employee =apiClientFactory.getEmployeeApi().findById(id);
        } catch (HttpClientErrorException exception) {
            return new CheckEmployeeRecord(
                    null,
                    exception.getStatusCode().equals(HttpStatus.NOT_FOUND)
                            ? HttpStatus.NOT_FOUND
                            : HttpStatus.SERVICE_UNAVAILABLE
            );
        } catch (RestClientException exception) {
            return new CheckEmployeeRecord(null, HttpStatus.INTERNAL_SERVER_ERROR);
        }
        return new CheckEmployeeRecord(employee, HttpStatus.OK);
    }
}
