package de.hmmh.pmt.util;

import de.hmmh.pmt.db.Project;
import de.hmmh.pmt.dtos.CreateProjectDTO;
import de.hmmh.pmt.dtos.CreatedProjectDTO;
import de.hmmh.pmt.dtos.Employee;
import de.hmmh.pmt.dtos.Qualification ;
import de.hmmh.pmt.employee.dtos.EmployeeResponseDTO;
import de.hmmh.pmt.employee.dtos.QualificationGetDTO;
import de.hmmh.pmt.dtos.UpdateProjectDTO;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class Mapper {
    public Project map(CreateProjectDTO dto) {
        Project project = new Project();
        project.setName(dto.getName());
        project.setGoal(dto.getGoal());
        project.setCustomerId(dto.getCustomerId());
        project.setAdministratorId(dto.getAdministratorId());
        project.setStart(dto.getStart());
        project.setPlannedEnd(dto.getPlannedEnd());
        return project;
    }
    
    public CreatedProjectDTO map(Project project) {
        CreatedProjectDTO dto = new CreatedProjectDTO();
        dto.setId(project.getId());
        dto.setName(project.getName());
        dto.setGoal(project.getGoal());
        dto.setCustomerId(project.getCustomerId());
        dto.setAdministratorId(project.getAdministratorId());
        dto.setStart(project.getStart());
        dto.setPlannedEnd(project.getPlannedEnd());
        return dto;
    }

    public Employee map(EmployeeResponseDTO employeeResponseDTO)  {
        Employee dto = new Employee();
        dto.setId(employeeResponseDTO.getId());
        dto.setLastName(employeeResponseDTO.getLastName());
        dto.setFirstName(employeeResponseDTO.getFirstName());
        dto.setStreet(employeeResponseDTO.getStreet());
        dto.setPostcode(employeeResponseDTO.getPostcode());
        dto.setCity(employeeResponseDTO.getCity());
        dto.setPhone(employeeResponseDTO.getPhone());

        List<Qualification > skillSet = employeeResponseDTO.getSkillSet().stream()
                .map(this::map)
                .toList();

        dto.setSkillSet(skillSet);
        return dto;
    }

    private Qualification  map(QualificationGetDTO qualificationGetDTO) {
        Qualification  dto = new Qualification ();
        dto.setId(qualificationGetDTO.getId());
        dto.setSkill(qualificationGetDTO.getSkill());
        return dto;
    }


    public Project map(Project project, UpdateProjectDTO dto) {
        project.setName(dto.getName());
        project.setGoal(dto.getGoal());
        project.setCustomerId(dto.getCustomerId());
        project.setAdministratorId(dto.getAdministratorId());
        project.setStart(dto.getStart());
        project.setPlannedEnd(dto.getPlannedEnd());
        return project;
    }
}
