package de.hmmh.pmt.project;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.delete;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import java.util.List;
import java.util.Map;

import org.junit.jupiter.api.Test;

import de.hmmh.pmt.IntegrationTest;
import de.hmmh.pmt.db.Project;

public class DeleteTest extends IntegrationTest {
    @Test
    void projectNotFound() throws Exception {
        mvc
            .perform(delete(baseUri + "/project/1"))
            .andExpect(status().isNotFound())
        ;
    }

    @Test
    void deletedSuccessfully() throws Exception {
        Map<String,Project> allProjects = createTestProjectData();
        mvc
            .perform(delete(baseUri + "/project/" + allProjects.get("space-station").getId()))
            .andExpect(status().isNoContent())
        ;
    }
}
