package de.hmmh.pmt.project;

import de.hmmh.pmt.IntegrationTest;
import de.hmmh.pmt.db.Project;
import de.hmmh.pmt.dtos.CreateProjectDTO;
import de.hmmh.pmt.dtos.UpdateProjectDTO;
import de.hmmh.pmt.employee.dtos.EmployeeResponseDTO;
import org.junit.jupiter.api.Test;
import org.mockito.Mockito;
import org.springframework.http.MediaType;
import org.springframework.test.web.servlet.RequestBuilder;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;

import java.util.Map;

import static org.mockito.Mockito.when;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

public class EditTest extends IntegrationTest {

    @Test
    void successfullyRenamed() throws Exception {
        when(this.mockEmployeeApi.findById(Mockito.anyLong()))
                .thenReturn(new EmployeeResponseDTO());

        Map<String, Project> allProjects = createTestProjectData();
        Project projectToEdit = allProjects.get("medical-research");

        UpdateProjectDTO dto = new UpdateProjectDTO();
        dto.setName("Mafia Drug Ring");
        dto.setGoal(projectToEdit.getGoal());
        dto.setCustomerId(projectToEdit.getCustomerId());
        dto.setAdministratorId(projectToEdit.getAdministratorId());
        dto.setStart(projectToEdit.getStart());
        dto.setPlannedEnd(projectToEdit.getPlannedEnd());

        this.mvc
                .perform(getRequest(projectToEdit.getId(), dto))
                .andExpect(status().isNoContent());
    }

    private RequestBuilder getRequest(long id, UpdateProjectDTO dto) throws Exception {
        return MockMvcRequestBuilders
                .put(baseUri + "/project/" + id)
                .content(this.objectMapper.writeValueAsString(dto))
                .contentType(MediaType.APPLICATION_JSON);
    }
}
